﻿Option Explicit On
Option Strict Off
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_80_Mask_91
Imports NM_Ahnen.Cls_30_Search

Public Class NM_Ahnen_Search
    Private WithEvents PrintDoc As New System.Drawing.Printing.PrintDocument
    REM ******************************************************************
    REM *  Hauptroutine                                                  *
    REM ******************************************************************
    Private Sub NM_Ahnen_10_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        PrintDoc.DefaultPageSettings.Landscape = Querformat
        Call Mask_Pos_91()
        Me.bt_91_Sort.Visible = False
        Me.Text = str_Search_Header + str_Sel_Anz
        Me.AcceptButton = bt_91_Go
    End Sub


    REM ******************************************************************
    REM *  Start des Searchvorgangs                                      *
    REM ******************************************************************
    Private Sub Bt_91_Go_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_91_Go.Click
        Call Verarb_Detail()
        Me.Text = str_Search_Header + str_Sel_Anz + str_Sort_Folge
        Me.bt_91_Sort.Visible = True
    End Sub
    REM ******************************************************************
    REM *  Abbruch, Cancel                                               *
    REM ******************************************************************
    Private Sub Bt_91_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_91_Cancel.Click
        Me.Close()
    End Sub
    REM **************************************************************
    REM *  Aufruf der Kurzerfassungsmaske                            *
    REM **************************************************************
    Private Sub Bt_91_Neu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_91_Neu.Click
        NM_Ahnen_PersK.Visible = True
    End Sub
    REM **************************************************************
    REM *  Aufruf des Druckerdialogs                                 *
    REM **************************************************************
    Private Sub Bt91_Print_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_91_Print.Click
        Me.PrintDialogS.ShowDialog()
        SpaltenBreitenErmitteln()
        PrintDoc.Print()
    End Sub
    REM **************************************************************
    REM *  Sortierung GridSpalten                                    *
    REM **************************************************************
    Private Sub Dgv_91_Tab_ColumnHeaderMouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles dgv_91_Tab.ColumnHeaderMouseClick
        Dim SortIndex As Integer
        SortIndex = e.ColumnIndex
        If SortIndex = 14 Then SortIndex = 15
        If SortIndex = 23 Then SortIndex = 24
        str_Sort_Search = str_t91_Head(SortIndex)
        If SortDir = "ASC" Then
            SortDir = "DESC"
        Else
            SortDir = "ASC"
        End If
        str_Sort_Search += " " + SortDir
    End Sub

    REM **************************************************************
    REM *  Auswahl aus Grid                                          *
    REM **************************************************************
    Private Sub Dgv_91_Tab_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_91_Tab.CellContentClick
        dbl_Sel_ID = Me.dgv_91_Tab.CurrentRow.Cells(0).Value
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus normaler Suchfunktion             *
        REM *  ausgewählte Person wird neue Person                   *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 1 Then
            dbl_ID = dbl_Sel_ID
            Call Person_Read_01()
            Me.Visible = False
        End If
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus Suchfunktion Vater                *
        REM *  ausgewählte Person wird neuer Vatereintrag            *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 2 Then
            Call Plausi_Vater()
            If int_Merk_Plausi_Search = 1 Then
                Exit Sub
            End If
            If int_Merk_Tab_Grund > 0 Then
                Call Person_Vater_Update()
                Call Person_Read_01()
            Else
                p_int_Vater = dbl_Sel_ID
                NM_Ahnen.tx_10_Vater.Text = dbl_Sel_ID.ToString
                Call Person_Read_Vater()
                Call Mask_Out_Vater()
            End If
            Me.Visible = False
        End If
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus Suchfunktion Mutter               *
        REM *  ausgewählte Person wird neuer Muttereintrag           *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 3 Then
            Call Plausi_Mutter()
            If int_Merk_Plausi_Search = 1 Then
                Exit Sub
            End If
            If int_Merk_Tab_Grund > 0 Then
                Call Person_Mutter_Update()
                Call Person_Read_01()
            Else
                p_int_Mutter = dbl_Sel_ID
                NM_Ahnen.tx_10_Mutter.Text = dbl_Sel_ID.ToString
                Call Person_Read_Mutter()
                Call Mask_Out_Mutter()
            End If
            Me.Visible = False
        End If
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus Suchfunktion Taufpate             *
        REM *  ausgewählte Person wird neuer Vatereintrag            *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 4 Then
            Call Plausi_Taufpate()
            If int_Merk_Plausi_Search = 1 Then
                Exit Sub
            End If
            Call Person_Paten_Insert()
            Call Person_Read_01()
            Me.Visible = False
        End If
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus Suchfunktion Ehepartner           *
        REM *  ausgewählte Person wird neuer Vatereintrag            *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 5 Then
            Call Plausi_Ehe()
            If int_Merk_Plausi_Search = 1 Then
                Exit Sub
            End If

            Call Person_Ehe_Insert()
            Call Person_Read_01()
            Me.Visible = False
        End If
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus Suchfunktion Trauzeuge Standesamt *
        REM *  ausgewählte Person wird neuer Vatereintrag            *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 6 Then
            Call Plausi_Trauzeuge()
            If int_Merk_Plausi_Search = 1 Then
                Exit Sub
            End If
            int_TZ_Typ = 8
            Call Person_Trauzeugen_Insert()
            Call Person_Read_01()
            Me.Visible = False
        End If
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus Suchfunktion Trauzeuge Kirche     *
        REM *  ausgewählte Person wird neuer Vatereintrag            *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 7 Then
            Call Plausi_Trauzeuge()
            If int_Merk_Plausi_Search = 1 Then
                Exit Sub
            End If
            int_TZ_Typ = 9
            Call Person_Trauzeugen_Insert()
            Call Person_Read_01()
            Me.Visible = False
        End If
        REM *--------------------------------------------------------*
        REM *  Aufruf erfolgte aus Listensuchfunktion                *
        REM *  ausgewählte Person wird Startperson                   *
        REM *--------------------------------------------------------*
        If int_Merk_STyp = 8 Then
            dbl_ID = dbl_Sel_ID
            Call Person_Read_t01_Basis()
            NM_Print.lbl_P_Name.Text = p_str_Name + ", " + p_str_Vorname
            NM_Print.tx_P_ID.Text = p_int_ID
            Me.Visible = False
        End If
    End Sub


    REM ******************************************************************
    REM *  Bestimmen der Gridspalten für Anzeige                         *
    REM ******************************************************************
    Public Shared Sub GridSpalten()
        REM *  Druckhilfsfelder löschen
        For int_SPZ1 = 0 To 15
            int_Druck_Spalte(int_SPZ1) = 0
            int_Druck_Spaltx(int_SPZ1) = 0
            int_Druck_TabID(int_SPZ1) = 0
            str_Druck_Spalte(int_SPZ1) = ""
            str_Druck_SpaltN(int_SPZ1) = ""
        Next
        With NM_Ahnen_Search

            str_Sort_Folge = "  / Sortierfolge: Name, Vorname, GebDat"
            Dim int_Col As Integer = .dgv_91_Tab.ColumnCount
            int_SPZ = 0
            For i1 = 0 To int_Col - 1
                If .dgv_91_Tab.Columns(i1).Visible = True Then
                    int_Col = .dgv_91_Tab.Columns(i1).Width
                    int_Druck_Spalte(i1) = .dgv_91_Tab.Columns(i1).Width
                    str_Druck_Spalte(i1) = .dgv_91_Tab.Columns(i1).HeaderText
                    int_SPZ += 1
                End If
            Next
            'int_SPZ = 8
        End With
    End Sub
    REM **************************************************************
    REM *  Ermitteln der Spaltenbreite relativ zu Seitenbreite       *
    REM **************************************************************
    Private Sub SpaltenBreitenErmitteln()
        Dim g As Graphics = Me.dgv_91_Tab.CreateGraphics
        SpaltenBreiten.Clear()
        For i1 = 0 To int_SPZ
            int_GBreite += (int_Druck_Spalte(i1))
        Next
    End Sub

    REM **************************************************************
    REM *  Ausdruck der Seite(n)                                     *
    REM **************************************************************
    Private Sub PrintDoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) _
                           Handles PrintDoc.PrintPage

        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        e.Graphics.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias

        ' ***** 
        ' * Höhe der Schrift ermitteln anhand der Schriftart(Font)
        ' * mittels Mustertext (mit Ober- und Unterlängen)
        ' * und Höhe geringfügig erhöhen
        ' ***** 
        Dim g As Graphics = Me.dgv_91_Tab.CreateGraphics
        TextHöhe = g.MeasureString("Bg", Me.dgv_91_Tab.Font).Height + ZellPadding ' Mustertext zur Ermittlung der Schrifthöhe
        HeaderHöhe = TextHöhe * 2

        With PrintDoc.DefaultPageSettings
            LRand = .Margins.Left                           ' Rand links
            RRand = .Margins.Right                          ' Rand rechts
            ROben = .Margins.Top                            ' Rand oben
            RUnten = .Margins.Bottom                        ' Rand unten

            PageWidth = .Bounds.Width - (RRand + LRand)     ' Druckbereich Breite
            PageHeight = .Bounds.Height - (ROben + RUnten)  ' Druckbereich Höhe
            e.Graphics.DrawRectangle(Pens.Black, LRand, ROben, PageWidth, PageHeight) ' Rahmen um alles
        End With
        ' *   Spaltenbreiten ermitteln prozentual zur Seitenbreite
        For i1 = 0 To int_SPZ
            SpaltenBreiten.Add(int_Druck_Spalte(i1) * PageWidth / int_GBreite)
        Next

        PosY = ROben
        PosX = LRand

        dgv_MaxZeilenIndex = Me.dgv_91_Tab.Rows.Count - 1
        dgv_MaxSpaltenIndex = int_SPZ

        sf.Alignment = StringAlignment.Near
        sf.LineAlignment = StringAlignment.Center

        'Call Druck_Spaltenkopf(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDoc.PrintPage)
        DruckSpalte = 0
        Do
            ZellBox = New Rectangle(PosX, PosY, SpaltenBreiten(DruckSpalte), HeaderHöhe)
            ZellInhalt = str_Druck_Spalte(DruckSpalte)

            e.Graphics.FillRectangle(New SolidBrush(HeaderColor), ZellBox)
            If DruckeGitternetzlinien = True Then
                e.Graphics.DrawRectangle(Pens.Black, ZellBox.X, ZellBox.Y, ZellBox.Width, ZellBox.Height)
            End If
            e.Graphics.DrawString(ZellInhalt, Me.dgv_91_Tab.Font, Brushes.Black, ZellBox, sf)

            PosX += SpaltenBreiten(DruckSpalte)
            DruckSpalte += 1
        Loop Until DruckSpalte > int_SPZ

        ' ***** Zeileninhalte drucken

        DruckZeile = 0
        PosX = LRand
        PosY = ROben + HeaderHöhe

        Do
            ' DruckSpalte = 0
            For i1 = 0 To int_SPZ - 1
                ZellInhalt = Me.dgv_91_Tab.Rows(DruckZeile + DGVZeilenIndex).Cells(i1).Value
                'ZellInhalt = Me.dgv_91_Tab.Rows(DruckZeile + DGVZeilenIndex).Cells(int_Druck_TabID(i1)).Value
                ZellBoxZ = New Rectangle(PosX, PosY, SpaltenBreiten(i1), TextHöhe)

                If Me.dgv_91_Tab.Columns(i1).DefaultCellStyle.Format.ToString <> String.Empty Then
                    ZellInhalt = CDbl(ZellInhalt).ToString(Me.dgv_91_Tab.Columns(i1).DefaultCellStyle.Format.ToString)
                End If

                ' If (DGVZeilenIndex + DruckZeile) Mod 2 = 0 Then ' Zeilen abwechselnd einfärben
                e.Graphics.FillRectangle(New SolidBrush(RowColor), ZellBoxZ)
                ' Else
                'e.Graphics.FillRectangle(New SolidBrush(RowColorAlternate), ZellBoxZ)
                'End If
                If DruckeGitternetzlinien = True Then
                    e.Graphics.DrawRectangle(Pens.Black, ZellBoxZ.X, ZellBoxZ.Y, ZellBoxZ.Width, ZellBoxZ.Height)
                End If

                ZellBoxZ = New Rectangle(PosX, PosY, SpaltenBreiten(i1), TextHöhe)
                e.Graphics.DrawString(ZellInhalt, Me.dgv_91_Tab.Font, Brushes.Black, ZellBoxZ, sf)
                PosX += SpaltenBreiten(i1)
                '  DruckSpalte += 1
            Next i1

            PosX = LRand
            PosY += TextHöhe
            DruckZeile += 1
        Loop Until ((DruckZeile + DGVZeilenIndex) > (dgv_MaxZeilenIndex)) OrElse ((PageHeight + ROben) < PosY + TextHöhe)

        If (DruckZeile + DGVZeilenIndex) > (dgv_MaxZeilenIndex) Then
            e.HasMorePages = False
            DGVZeilenIndex = 0
            DruckSpalte = 0
            DruckZeile = 0
            Exit Sub
        Else
            e.HasMorePages = True
            DGVZeilenIndex = DruckZeile + DGVZeilenIndex
            Exit Sub
        End If
    End Sub

    Private Sub Druck_Spaltenkopf()
        ' ***** Spaltenköpfe drucken
    End Sub
    REM *-------------------------------------------------------------------*
    REM *  Focussteuerung bei Search-Eingabe                                *
    REM *-------------------------------------------------------------------*
    Private Sub Tx_91_Name_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_Name_von.TextChanged
        If Len(Me.tx_91_Name_von.Text) = 50 Then
            Me.tx_91_Name_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_Name_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_Name_bis.TextChanged
        If Len(Me.tx_91_Name_bis.Text) = 50 Then
            Me.tx_91_Vorname_von.Focus()
        End If
    End Sub

    Private Sub Tx_91_Vorname_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_Vorname_von.TextChanged
        If Len(Me.tx_91_Vorname_von.Text) = 50 Then
            Me.tx_91_Vorname_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_Vorname_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_Vorname_bis.TextChanged
        If Len(Me.tx_91_Vorname_bis.Text) = 50 Then
            Me.tx_91_Geschlecht.Focus()
        End If
    End Sub

    Private Sub Tx_91_GDat_TT_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GDat_TT_von.TextChanged
        If Len(Me.tx_91_GDat_TT_von.Text) = 2 Then
            Me.tx_91_GDat_MM_von.Focus()
        End If
    End Sub

    Private Sub Tx_91_GDat_MM_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GDat_MM_von.TextChanged
        If Len(Me.tx_91_GDat_MM_von.Text) = 2 Then
            Me.tx_91_GDat_JJ_von.Focus()
        End If
    End Sub

    Private Sub Tx_91_GDat_JJ_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GDat_JJ_von.TextChanged
        If Len(Me.tx_91_GDat_JJ_von.Text) = 4 Then
            Me.tx_91_GDat_TT_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_GDat_TT_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GDat_TT_bis.TextChanged
        If Len(Me.tx_91_GDat_TT_bis.Text) = 2 Then
            Me.tx_91_GDat_MM_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_GDat_MM_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GDat_MM_bis.TextChanged
        If Len(Me.tx_91_GDat_MM_bis.Text) = 2 Then
            Me.tx_91_GDat_JJ_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_GDat_JJ_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GDat_JJ_bis.TextChanged
        If Len(Me.tx_91_GDat_JJ_bis.Text) = 4 Then
            Me.tx_91_GOrt_von.Focus()
        End If
    End Sub

    Private Sub Tx_91_GOrt_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GOrt_von.TextChanged
        If Len(Me.tx_91_GOrt_von.Text) = 50 Then
            Me.tx_91_GOrt_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_GOrt_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_GOrt_bis.TextChanged
        If Len(Me.tx_91_GOrt_bis.Text) = 50 Then
            Me.tx_91_SDat_TT_von.Focus()
        End If
    End Sub

    Private Sub Ttx_91_SDat_TT_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SDat_TT_von.TextChanged
        If Len(Me.tx_91_SDat_TT_von.Text) = 2 Then
            Me.tx_91_SDat_MM_von.Focus()
        End If
    End Sub

    Private Sub Tx_91_SDat_MM_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SDat_MM_von.TextChanged
        If Len(Me.tx_91_SDat_MM_von.Text) = 2 Then
            Me.tx_91_SDat_JJ_von.Focus()
        End If
    End Sub

    Private Sub Tx_91_SDat_JJ_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SDat_JJ_von.TextChanged
        If Len(Me.tx_91_SDat_JJ_von.Text) = 4 Then
            Me.tx_91_SDat_TT_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_SDat_TT_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SDat_TT_bis.TextChanged
        If Len(Me.tx_91_SDat_TT_bis.Text) = 2 Then
            Me.tx_91_SDat_MM_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_SDat_MM_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SDat_MM_bis.TextChanged
        If Len(Me.tx_91_SDat_MM_bis.Text) = 2 Then
            Me.tx_91_SDat_JJ_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_SDat_JJ_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SDat_JJ_bis.TextChanged
        If Len(Me.tx_91_SDat_JJ_bis.Text) = 4 Then
            Me.tx_91_SOrt_von.Focus()
        End If
    End Sub

    Private Sub Tx_91_SOrt_von_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SOrt_von.TextChanged
        If Len(Me.tx_91_SDat_JJ_bis.Text) = 50 Then
            Me.tx_91_SOrt_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_SOrt_bis_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_SOrt_bis.TextChanged
        If Len(Me.tx_91_SDat_JJ_bis.Text) = 50 Then
            Me.tx_91_SOrt_bis.Focus()
        End If
    End Sub

    Private Sub Tx_91_Geschlecht_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_91_Geschlecht.TextChanged
        If Len(Me.tx_91_Geschlecht.Text) = 1 Then
            Me.tx_91_Name_von.Focus()
        End If
    End Sub
    Private Sub Bt91_Sort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_91_Sort.Click
        NM_Ahnen_Sort.Show()
    End Sub

End Class
